namespace PlcSiemens.Protocol.Szl
{
    public class SzlCmd
    {
        public ushort ID { get; set; }
        public ushort Index { get; set; }
    }

    public static class SzlInfo
    {
        public static SzlCmd OrderCode = new SzlCmd { ID = 0x0011, Index = 0x0000 };
        public static SzlCmd CpuInfo = new SzlCmd { ID = 0x001C, Index = 0x0000 };
        public static SzlCmd CpInfo = new SzlCmd { ID = 0x0131, Index = 0x0001 };
        public static SzlCmd ReadSzlAll = new SzlCmd { ID = 0x0000, Index = 0x0000 };
        public static SzlCmd PlcStatus = new SzlCmd { ID = 0x0424, Index = 0x0000 };
        public static SzlCmd Protection = new SzlCmd { ID = 0x0232, Index = 0x0004 };
    }
}
