﻿using System.ComponentModel;

namespace WCS.Entity.Protocol.Station
{
    /// <summary>
    /// 输送机状态读取协议
    /// </summary>
    public interface IStation523 : IProtocol
    {
        /// <summary>
        /// 警报
        /// </summary>
        [Description("警报")]
        StationAlarm Alarm { get; set; }

        /// <summary>
        /// 设备心跳信息号
        /// </summary>
        [Description("备用")]
        short RES { get; set; }

        /// <summary>
        /// 状态
        /// </summary>
        [Description("状态")]
        StationStatus Status { get; set; }

        /// <summary>
        /// 运行时间
        /// </summary>
        [Description("运行时间")]
        [IgnoreChanging]
        float RunTime { get; set; }

        /// <summary>
        ///  运行状态位
        /// </summary>
        [Description("运行状态位")]
        StationStatus1 Status1 { get; set; }
    }
}
