﻿namespace WCS.WorkEngineering.WebApi.Models.WMS.Request
{
    /// <summary>
    ///  环形库申请码垛出库任务
    /// </summary>
    public class RingApplyPalletizingStockOutRequest
    {
        /// <summary>
        ///  环形库申请码垛出库任务
        /// </summary>
        /// <param name="wareHouseCode"></param>
        /// <param name="equCode"></param>
        /// <param name="device"></param>
        public RingApplyPalletizingStockOutRequest(string wareHouseCode, string equCode, string device)
        {
            WareHouseCode = wareHouseCode;
            EquCode = equCode;
            Device = device;
        }

        /// <summary>
        /// 仓库编码
        /// </summary>
        public string WareHouseCode { get; set; }

        /// <summary>
        /// 设备编号
        /// </summary>
        public string EquCode { get; set; }

        /// <summary>
        ///  机械臂
        /// </summary>
        public string Device { get; set; }
    }
}
