﻿using WCS.WorkEngineering.WebApi.Models.WMS.Response;

namespace WCS.WorkEngineering.WebApi.Models.AGV.Response
{
    /// <summary>
    ///  agv补空返回参数
    /// </summary>
    public class ApplyEmptySpoolResponse
    {
        /// <summary>
        ///  站台编号
        /// </summary>
        public string LocCode { get; set; }

        /// <summary>
        ///  工字轮类型
        /// </summary>
        public string SpoolType { get; set; }

        /// <summary>
        ///  返回状态码
        /// </summary>
        public ResponseStatusCodeEnum ResCode { get; set; }

        /// <summary>
        ///  描述信息
        /// </summary>
        public string ResMsg { get; set; }

        /// <summary>
        ///  任务号
        /// </summary>
        public string TaskCode { get; set; }
    }
}
