﻿using System.ComponentModel;

namespace WCS.Core
{
    public enum PLCType
    {
        [Description("西门子")]
        Siemens = 1,

        [Description("三菱")]
        Mitsubishi = 2,

        [Description("欧姆龙")]
        Omron = 3,
    }

    public struct PLCInfo
    {
        public string IP { get; set; }
        public int Port { get; set; }
        public int Slot { get; set; }
        public int Rack { get; set; }
        public PLCType Type { get; set; }
    }

    public struct DBInfo
    {
        public PLCInfo PLCInfo { get; set; }
        public ushort No { get; set; }
    }

    public struct ProtocolInfo
    {
        public DBInfo DBInfo { get; set; }
        public int Position { get; set; }
    }
}
