﻿using SqlSugar;
using System;
using System.Runtime.Serialization;

namespace WCS.Entity.Protocol.Station
{
    /// <summary>
    ///  523
    /// </summary>
    [DataContract]
    [SugarTable("FJ_Station523")]
    public class WCS_Station523 : IStation523
    {
        /// <inheritdoc/>
        [DataMember(Order = 0)]
        public StationAlarm Alarm { get; set; }

        /// <inheritdoc/>
        [DataMember(Order = 1)]
        public short RES { get; set; }

        /// <inheritdoc/>
        [DataMember(Order = 2)]
        public StationStatus Status { get; set; }

        /// <inheritdoc/>
        [DataMember(Order = 3)]
        public float RunTime { get; set; }

        /// <inheritdoc/>
        [DataMember(Order = 4)]
        public StationStatus1 Status1 { get; set; }

        [DataMember(Order = 5)]
        public new DateTime Frame { get; set; }

        [DataMember(Order = 6)]
        public new string Code { get; set; }
    }
}
