﻿using PlcSiemens.Core.Extension;
using ServiceCenter.Extensions;
using ServiceCenter.SqlSugars;
using System.ComponentModel;
using WCS.Core;
using WCS.Entity;
using WCS.Entity.Protocol.Station;
using WCS.WorkEngineering.Worlds;
using DeviceFlags = WCS.WorkEngineering.Extensions.DeviceFlags;
using TaskStatus = WCS.Entity.TaskStatus;

namespace WCS.WorkEngineering.Systems
{
    /// <summary>
    ///  桁架码垛区补空托盘任务生成
    /// </summary>
   // [BelongTo(typeof(SortingPalletizingWorld))]
    [Description("码垛区补空托盘任务生成")]
    public class PalletizCreateEmptyTray : DeviceSystem<Device<IStation520>>
    {
        protected override bool ParallelDo => true;

        

        public override void Do(Device<IStation520> obj)
        {

        }

        public override bool Select(Device dev)
        {
            return dev.Code == nameof(PalletizCreateEmptyTray);
        }
    }
}
