﻿using wms.dto;

namespace WCS.WorkEngineering.WebApi.Models.WMS.Request
{
    public class FJBingPalletRequest
    {
        /// <summary>
        ///  仓库号
        /// </summary>
        public string WarehouseCode { get; set; }

        /// <summary>
        ///  托盘条码
        /// </summary>
        public string PalletCode { get; set; }

        /// <summary>
        ///  工字轮任务号集合
        /// </summary>
        public List<string> TaskCode { get; set; }

        /// <summary>
        ///  业务类型
        /// </summary>
        public FJTaskBusType BusType { get; set; }

        /// <summary>
        ///  任务申请设备
        /// </summary>
        public string loc { get; set; }

        /// <summary>
        ///  是否异常
        /// </summary>
        public bool IsFail { get; set; }

        /// <summary>
        ///  异常原因
        /// </summary>
        public string FailReason { get; set; }

        /// <summary>
        ///  是否结束
        /// </summary>
        public bool IsFinish { get; set; }

        /// <summary>
        ///  是否为半跺入库
        /// </summary>
        public bool IsItHalf { get; set; }
    }
}
